import java.io.*;

public class CyrillicWinReader extends Reader { 
    public CyrillicWinReader(InputStream stream) { 
        this.stream = stream;
    }
    
    public int read(char[] cbuf, int off, int len) throws IOException { 
        byte[] buf = new byte[len];
        int rc = stream.read(buf, 0, len);
        for (int i = 0; i < rc; i++) { 
            byte b = buf[i];
            cbuf[off++] = (char)(b < 0 ? b == -88 ? 0x401 : b == -72 ? 0x451 : 
                                 (0x400 | ((b & 0x7f) - 0x30)) : b);
        }
        return rc;
    }


    public void close() throws IOException { 
        stream.close();
    }

    private InputStream stream;
}